# This examples shows that you can use Cocoa calls (through PyObjC)
# to draw directly. This has _much_ more features (Cocoa is very rich),
# but is also harder to use.

import os
from Foundation import *
from AppKit import *

appBundle = NSBundle.mainBundle()
path = appBundle.pathForResource_ofType_("DrawBotFile.icns", None)
image = NSImage.alloc().initWithContentsOfFile_(path)

t = NSAffineTransform.transform()
t.scaleBy_(3)
t.rotateByDegrees_(5)
t.translateXBy_yBy_(15, 5)
t.set()


srcRect = ((0, 0), image.size())
image.drawAtPoint_fromRect_operation_fraction_((0, 0),
    srcRect, NSCompositeSourceOver, 1.0)

# Note: images created from PDF can't be drawn transparently!
