# size: 400 400
w,h = 400, 400

defineInterface(
    Slider(name='maxCircleRadius', maxValue=20.0, default=10.0),
    Slider(name='largeRotation', maxValue=10.0, default=0.5),
    Slider(name='smallRotation', maxValue=10.0),
    Slider(name='tinyRotation', maxValue=10.0),
    Checkbox(name='useThickOutline', default=True),
    ColorWell(name='outlineColor', default='black'),
)

steps = 720
halfSteps = steps / 2
rotation = largeRotation + (smallRotation * 0.1) + (tinyRotation * 0.01)

cx, cy = w/2, h/2
phi = (sqrt(5) + 1)/2-1
oradius = maxCircleRadius

def spiralCircle(radius, step):
    return Oval(cx-(radius/2) + 0.25*step*cos(phi*step*rotation), 
                cy-(radius/2) + 0.25*step*sin(phi*step*rotation), 
                radius, radius)

for i in range(720):
    if useThickOutline:
        outlineColor.set()
        radius = 1.5*oradius * sin(i * pi/steps)
        r = spiralCircle(radius, i)
        r.fill()

    radius = oradius * sin(i * pi/steps)
    r = spiralCircle(radius, i)
    Color(i / halfSteps, i / halfSteps, 0.25).set()
    r.fill()
    if not useThickOutline:
        outlineColor.set()
        r.stroke()