from AppKit import *
from random import random


__all__ = ["Rect", "Oval", "BezierPath", "Color", "Gray", "random"]


class BezierPath(object):

    def __init__(self, path=None):
        if path is None:
            path = NSBezierPath.bezierPath()
        self.path = path

    def moveto(self, x, y):
        self.path.moveToPoint_((x, y))

    def lineto(self, x, y):
        self.path.lineToPoint_((x, y))

    def curveto(self, x1, y1, x2, y2, x3, y3):
        self.path.curveToPoint_controlPoint1_controlPoint2_((x3, y3), (x1, y1), (x2, y2))
    
    def closepath(self):
        self.path.closePath()
    
    def setlinewidth(self, w):
        self.path.setLineWidth_(w)

    def fill(self):
        self.path.fill()

    def stroke(self):
        self.path.stroke()


def Rect(x, y, w, h):
    return BezierPath(NSBezierPath.bezierPathWithRect_(((x, y), (w, h))))

def Oval(x, y, w, h):
    return BezierPath(NSBezierPath.bezierPathWithOvalInRect_(((x, y), (w, h))))


class Color(object):

    def __init__(self, r, g, b, alpha=1):
        self.color = NSColor.colorWithCalibratedRed_green_blue_alpha_(r, g, b, alpha)

    def set(self):
        self.color.set()

def Gray(g, alpha=1):
    return Color(g, g, g, alpha)


# XXX
# Text stuff
# Transformations
