# size: 400 400
w,h = 400, 400
cx, cy = w/2, h/2
radius = 180

defineInterface(
    Slider(name='sides', minValue=2, maxValue=16, 
           tickMarks=(16-2), clamp=True, default=3),
    ColorWell(name='outlineColor', default='black'),
)
# range can only take integer values
sides = int(sides)
path = BezierPath()
path.moveto(cx+radius*cos(0), cy+radius*sin(0))
for side in range(1, sides+1):
    angle = (side/sides)*2*pi
    path.lineto(cx+radius*cos(angle), cy+radius*sin(angle))
outlineColor.set()
path.stroke()