from bundlebuilder import buildapp
from plistlib import Plist, Dict
import os

def makeHelp():
    try:
        os.mkdir('Resources/English.lproj/DrawBot Help')
    except:
        pass
    out = file('Resources/English.lproj/DrawBot Help/index.html', 'w')
    out.write("""<html>
<html>
<head>
<META HTTP-EQUIV="content-type" CONTENT="text/html;charset=iso-8859-1" />
<META NAME="AppleTitle" CONTENT="DrawBot Help" />
<title>DrawBot Help</title>
</head>
<body>
""")
    out.write('<br />\n'.join(file('ReadMe.txt').read().splitlines()))
    out.write("""</body></html>""")
    out.close()
    
makeHelp()

plist = Plist(
    CFBundleDocumentTypes = [
        Dict(
            CFBundleTypeExtensions = ["py"],
            CFBundleTypeName = "Python Source File",
            CFBundleTypeRole = "Editor",
            NSDocumentClass = "DrawBotDocument",
            CFBundleTypeIconFile = "DrawBotFile.icns",
        ),
    ],
    CFBundleHelpBookName = "DrawBot Help",
    CFBundleHelpBookFolder = "DrawBot Help",
    CFBundleIdentifier = "com.letterror.DrawBot",
    LSMinimumSystemVersion = "10.2.0",
    CFBundleShortVersionString = "0.9a2",
)


buildapp(
    name = "DrawBot",
    mainprogram = "DrawBot.py",
    resources = ["Resources/English.lproj",
                 "Resources/DrawBotFile.icns",
                 "Resources/Credits.rtf",
                 "Renaissance",],
    exclude = "Renaissance",
    nibname = "MainMenu",
    plist = plist,
    iconfile = "Resources/DrawBot.icns",
    includePackages = ["encodings"],
)
