import os
import sys
import shutil
import re


entryRE = re.compile("^(D?)/(.*?)/")

def gatherFiles(dir, top=""):
    entries = []
    for line in file(os.path.join(dir, "CVS", "Entries")):
        m = entryRE.match(line)
        if not m:
            continue
        name = m.group(2)
        if m.group(1):
            sub = gatherFiles(os.path.join(dir, name), os.path.join(top, name))
            entries.extend(sub)
        else:
            entries.append(os.path.join(top, name))
    return entries


def copyFiles(srcDir, dstDir, entries):
    for entry in entries:
        src = os.path.join(srcDir, entry)
        dst = os.path.join(dstDir, entry)
        dir = os.path.dirname(dst)
        if not os.path.exists(dir):
            os.makedirs(dir)
        shutil.copy(src, dst)


selfPath = os.path.normpath(os.path.abspath(sys.argv[0]))
dir = os.path.dirname(selfPath)

distDir = os.path.join(dir, "build", "dist")

if os.path.exists(distDir):
    shutil.rmtree(distDir)

binDir = os.path.join(distDir, "DrawBot")
srcDir = os.path.join(distDir, "DrawBotSources")


print "Making source distribution (%r)" % srcDir
copyFiles(dir, srcDir, gatherFiles(dir))

print "Making binary distribution (%r)" % binDir
os.chdir(dir)
command = "%s buildapp.py -b %r --standalone --strip build" % (sys.executable, binDir)
os.system(command)
examplesDir = os.path.join(dir, "Examples")
copyFiles(examplesDir, os.path.join(binDir, "Examples"), gatherFiles(examplesDir))
shutil.copy(os.path.join(dir, "ReadMe.txt"), os.path.join(binDir, "ReadMe.txt"))
print "Done."
